mod Ex09b

incl Mtex

incl Mtexbt

incl Mauxb

loc rem 
  \para \bf  9. CVIČENIE Z PREDMETU 1-AIN-470 ŠPECIFIKÁCIA A VERIFIKÁCIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.21 
  \para* \it  Dátum:  \end utorok 28.4.2015 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-470-svp/1415ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované Braunovym 
  stromom a haldám. Zadanie sa skladá z týchto súborov: 
  \items 
   \item \para Súbory \it  mtex*.cl  \end obsahujú makrá pre CL-TeX. 
   \item \para Súbory \it  maux*.cl  \end obsahujú definície niektorých 
         funkcií a predikátov. 
   \item \para Súbory \it  ex*.cl  \end obsahujú úlohy, ktoré máte riešiť 
         na tomto cvičení. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje základnú syntax systému 
         CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara. Specification and Verification of 
         Programs. Downloadable lecture notes available through the web page of 
         the course. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Programs Operating on Trees.  \end 

rem 
  \para \bf  Section. Binary Trees.  \end 

rem 
  \para \bf  Subsection. Basic Operations and Predicates.  \end 

rem 
  \para \bf  Permutations.  \end \header* pred/2 Perm 'Tex_p2_bt_perm' \end 
  Given binary trees \ft t1 \end and \ft t2 \end, the predicate 
  \ft Perm(t1,t2) \end holds if the trees \ft t1 \end and \ft t2 \end are 
  permutations of each other. 

pred/2 Perm 'Tex_p2_bt_perm'
  Perm(t1,t2) <-> \a x Count(x,t1) = Count(x,t2)

rem 
  \para \bf  Section. Applications of Trees.  \end 

rem 
  \para \bf  Subsection. Heaps and Priority Queues.  \end 

rem 
  \para \bf  Heaps.  \end 

pred/2 Ge 'Tex_p2_bt_ge'
  Ge(x,t) <-> \a y(Inbt(y,t) -> x >= y)

pred Heap 
  Heap(t) <-> Brt(t) & \a x\a l\a r(Subtree(Nd(x,l,r),t) -> Ge(x,l) & Ge(x,r))

rem 
  \para We have 
  \eq* 
    Heap(E)
  \end
  \eq* 
    Heap Nd(x,l,r) <-> 
    (Sz(l) = Sz(r) \/ Sz(l) = Sz(r)+1) & Ge(x,l) & Ge(x,r) & Heap(l) & Heap(r)
  \end

rem 
  \para \bf  Maintaining the heap property.  \end Define the function 
  \ft Heapify(t) \end such that 
  \eq* 
    Heap(t) & t != E -> Heap Heapify Update(t,0,x)
  \end
  \eq* 
    Heap(t) & t != E -> Perm(Heapify Update(t,0,x),Update(t,0,x))
  \end

fun Heapify 
  Heapify(t) = Foo

rem 
  \para \bf  Building a heap.  \end Define the function \ft Brt2heap(t) \end 
  such that 
  \eq* 
    Brt(t) -> Heap Brt2heap(t)
  \end
  \eq* 
    Brt(t) -> Perm(Brt2heap(t),t)
  \end

fun Brt2heap 
  Brt2heap(t) = Foo

rem 
  \para \bf  The enqueue operation.  \end \header* fun/2 Enqueue  \end Define 
  the function \ft Enqueue(t,x) \end such that 
  \eq* 
    Heap(t) -> Heap Enqueue(t,x)
  \end
  \eq* 
    Heap(t) -> Sz Enqueue(t,x) = Sz(t)+1
  \end
  \eq* 
    Heap(t) -> Count(y,Enqueue(t,x)) = Count(y,t)+Eqf(y,x)
  \end

fun/2 Enqueue 
  Enqueue(t,x) = Foo

rem 
  \para \bf  The dequeue operation.  \end Define the function 
  \ft Dequeue(t) \end such that 
  \eq* 
    Heap(t) & t != E -> Heap Dequeue(t)
  \end
  \eq* 
    Heap(t) & t != E -> Sz Dequeue(t,x) = Sz(t)-1
  \end
  \eq* 
    Heap(t) & t != E -> Count(x,Dequeue(t))+Eqf(x,Lookup(t,0)) = Count(x,t)
  \end

fun Dequeue 
  Dequeue(t) = Foo

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Split 
  Split(0) = 0,0
  Split(u,0) = (u,0),0
  Split(u,v,w) = (u,y),v,z <- Split(w) = y,z

loc fun Ln2brt 
  Ln2brt(0) = E
  Ln2brt(v,w) = Nd(v,Ln2brt(y),Ln2brt(z)) <- Split(w) = y,z

loc fun/2 Ln2heap 
  Ln2heap(0,t) = t
  Ln2heap((v,w),t) = Ln2heap(w,Enqueue(t,v))

loc fun/2 Enq 
  Enq(0,t) = t
  Enq((v,w),t) = Enq(w,Enqueue(t,v))

loc fun/2 Deq 
  Deq(0,t) = t
  Deq(n+1,t) = Deq(n,Dequeue(t))

